/*
  DeBounce.h - A library for debouncing switch inputs
  Paul MacDougal
  May 2015

  This work is licensed under the Creative Commons Attribution 4.0 International License.
  To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/ or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.
*/

#ifndef DeBounce_h
#define DeBounce_h

#define DeBounce_UP            0
#define DeBounce_DOWN          1
#define DeBounce_RISING        2
#define DeBounce_FALLING       3
#define DeBounce_PRESS         4
#define DeBounce_FIRST_RISING  5
#define DeBounce_THIS_SHOULD_NEVER_HAPPEN 99

class DeBounce {
 private:
     unsigned char m_sw_pin;
     unsigned char m_red_level;
     unsigned char m_state;
     unsigned long m_startTime;
     unsigned long m_lastFalling;
     unsigned long m_settleTime;
    
 public:
    DeBounce();
    ~DeBounce();
    unsigned char init(unsigned char pin, unsigned char redLevel, unsigned long settleTime);
    unsigned char handleInput();
    unsigned long getDuration();

};


#endif	//DeBounce.h



